unit gr32frm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  GR32_ImageFX, // this is main ImageFX unit for Graphics32
  GR32, GR32_Layers, GR32_RangeBars, ExtCtrls, GR32_Image, StdCtrls;

type
  TForm5 = class(TForm)
    ImgView321: TImgView32;
    Panel1: TPanel;
    GaugeBar1: TGaugeBar;
    Label1: TLabel;
    SourceImage: TImage32;
    GaugeBar2: TGaugeBar;
    Label2: TLabel;
    Label3: TLabel;
    GaugeBar3: TGaugeBar;
    Label4: TLabel;
    procedure GaugeBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImgView321MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer; Layer: TCustomLayer);
  private
    { Private declarations }
    FCenter: TPoint;
    procedure ApplyFilter;
  public
    { Public declarations }
  end;

var
  Form5: TForm5;

implementation

{$R *.dfm}

procedure TForm5.FormCreate(Sender: TObject);
begin
  FCenter := Point(220, 500); // Ripple center in pixel
  // first time
  ApplyFilter;
end;

procedure TForm5.ApplyFilter;
var
  F: TRipple32;
begin
  F := TRipple32.Create(nil);
  // Set source image - better to use 32-bit TBitmap, other TBitmap or TGraphic need to be convert
  F.Input := SourceImage.Bitmap;
  // Set Filter's values
  F.Phase := GaugeBar1.Position;
  F.Amplitude := GaugeBar2.Position / 100;
  F.Frequency := GaugeBar3.Position;
  F.AspectRatio := 0.7;
  F.Center := FCenter;
  // Get result image (apply filter)
  ImgView321.Bitmap.Assign(F.Output);
  // Free Filter
  F.Free;
end;

procedure TForm5.GaugeBar1Change(Sender: TObject);
begin
  ApplyFilter;
end;

procedure TForm5.ImgView321MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer; Layer: TCustomLayer);
begin
  if not (ssLeft in Shift) then Exit;
  // New Ripple center
  with ImgView321.ControlToBitmap(Point(X, Y)) do
    FCenter := Point(x, y);
  // Apply Filter
  ApplyFilter;
end;

end.
